VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsEngine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'########### pomocne promenne ###############################

Public CamposX As Single
Public CamposY As Single
Public CamposZ As Single
Public CamrotY As Single
Public CamrotX As Single
Public CamrotZ As Single

'#############################################################
Private hrc As Long 'Trval Rendering Context
Public active As Boolean 'Ponese informaci o tom, zda je okno aktivn
Private Window As mWindow 'pomocna struktura naseho okna

Private Type mWindow
  Width As Integer 'nova  vyska
  Height As Integer 'nova sirka
  Bits As Integer 'nova bitova hloubka (8, 16, 24 nebo 32 bitu)
  oldWidth As Integer 'soucana vyska
  oldHeight As Integer 'soucana sirka
End Type

Private Cam As m_Camera

Private Type POINTAPI
  x As Long
  y As Long
End Type

Private Type m_Camera
  posx As Single
  posy As Single
  posz As Single
  roty As Single
  rotx As Single
  rotz As Single
End Type


Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function SetCursorPos Lib "user32" (ByVal x As Long, ByVal y As Long) As Long

Public Function CreateWindow(ByRef frm As Object, Optional ByVal Width As Integer = 640, _
  Optional ByVal Height As Integer = 480, Optional ByVal Bits As Integer = 16) As Boolean
Dim PixelFormat As GLuint, pfd As PIXELFORMATDESCRIPTOR
On Error GoTo Chyba
  
  With Window
    .Width = Width
    .Height = Height
    .Bits = Bits
  End With
  
  frm.WindowState = vbMaximized
  'nastaveni pocatecni pozice kamery 'NOVE
  With Cam
    .posz = -20
    .roty = 180
  End With
        
  Call SetCursorPos(Window.Width / 2, Window.Height / 2)
  '_____________________
  pfd.cColorBits = Bits
  pfd.cDepthBits = Bits
  pfd.dwFlags = PFD_DRAW_TO_WINDOW Or PFD_SUPPORT_OPENGL Or PFD_DOUBLEBUFFER Or PFD_TYPE_RGBA
  pfd.iLayerType = PFD_MAIN_PLANE
  pfd.iPixelType = PFD_TYPE_RGBA
  pfd.nSize = Len(pfd)
  pfd.nVersion = 1
    
  PixelFormat = ChoosePixelFormat(frm.hDC, pfd)
  
  If PixelFormat = 0 Then Err.Raise 1
  If SetPixelFormat(frm.hDC, PixelFormat, pfd) = 0 Then Err.Raise 2
    
  hrc = wglCreateContext(frm.hDC)
  
  If hrc = 0 Then Err.Raise 3
  If wglMakeCurrent(frm.hDC, hrc) = 0 Then Err.Raise 4
  If Not InitGL() Then Err.Raise 5
  
  frm.Show
  SetForegroundWindow frm.hWnd
  frm.SetFocus
  
  CreateWindow = True
  active = True
Exit Function

Chyba:

  
  KillWindow (frm)
  CreateWindow = False
  
  Select Case Err.Number
    Case 1
      MsgBox "Nepodailo se najt PixelFormat.", vbExclamation, "Chyba..."
    Case 2
      MsgBox "Nepodailo se nastavit PixelFormat.", vbExclamation, "Chyba..."
    Case 3
      MsgBox "Nepodailo se vytvoit Rendering Context.", vbExclamation, "Chyba..."
    Case 4
      MsgBox "Nepodailo se aktivovat Rendering Context.", vbExclamation, "Chyba..."
    Case 5
      MsgBox "Nepodailo se vytvoit okno.", vbExclamation, "Chyba..."
  End Select
  Err.Clear
End Function

Public Sub KillWindow(ByRef frm As Object)
  ' uvolnuje RC a odstrani okno
  
  If hrc Then
    If wglMakeCurrent(0, 0) = 0 Then MsgBox "Uvolneni Rendering Contextu se nepodarilo.", vbInformation
    If wglDeleteContext(hrc) = 0 Then MsgBox "Odstraneni Rendering Contextu se nepodarilo.", vbInformation
    hrc = 0
  End If
 
  Unload frm
  
End Sub

Public Function InitGL() As Boolean
  'inicializace OpenGL okna
  glShadeModel smSmooth 'povol jemn stnovn
  glClearColor 0#, 0#, 0#, 0# 'cern pozad RGB+Alpha
  glClearDepth 1# ' nastaven hloubkovho bufferu
  glEnable glcDepthTest 'povol hloubkov testovn
  glDepthFunc GL_LEQUAL ' typ hloubkovho testovn
  glHint htPerspectiveCorrectionHint, hmNicest 'nejlep perspektivn korekce
  InitGL = True
  
End Function

Public Sub ReSizeGLScene(ByVal Width As GLsizei, ByVal Height As GLsizei)
'tato procedura je volana vzdy kdyz dojde ke zmene velikosti OpenGL okna
  
  If Height = 0 Then Height = 1 'zabezpeceni proti deleni nulou
  
  glViewport 0, 0, Width, Height 'Resetuje aktuln nastaven (jako LPRect)
  glMatrixMode mmProjection 'Zvol projekn matici
  glLoadIdentity 'Reset matice
  gluPerspective 45#, Width / Height, 1, 6000# ' Vpoet perspektivy
  glMatrixMode mmModelView 'Zvol matici Modelview
  glLoadIdentity 'Reset matice
  
End Sub
'camera 'NOVE
Public Sub CameraMove(ByVal Keycode As Integer)
Dim mouse As POINTAPI 'ulozeni pozice mysi
Dim steepRotX As Single 'krok rotace na ose X
Dim steepPosX As Single, steepPosY As Single 'krok posunu X, Y
Static lastX As Integer 'pomocna promenna pro urceni smeru rotace plus nebo minus

steepRotX = 8
steepPosX = 1.6
steepPosY = 3

Select Case Keycode
  Case 0 'filtrujeme pozici mysi
    GetCursorPos mouse
    If mouse.x > lastX Then  'otoceni doprava
      'urceni rozsahu snimani pozice mysi (pomocne)
      If mouse.x < Window.Width - 10 Then
        Cam.roty = IIf(Abs(Cam.roty) = 359, 0, (Cam.roty - steepRotX))
      Else
        'pokud dosahneme praveho okraje okna, presuneme se zpet do jeho stredu
        SetCursorPos Window.Width / 2, mouse.y
        Cam.roty = IIf(Abs(Cam.roty) = 359, 0, (Cam.roty - steepRotX))
      End If
    ElseIf mouse.x < lastX Then 'otoceni doleva
      'urceni rozsahu snimani pozice mysi (pomocne)
      If mouse.x > 10 Then
        Cam.roty = IIf(Abs(Cam.roty) = 359, 0, (Cam.roty + steepRotX))
      Else
        'pokud dosahneme praveho okraje okna, presuneme se zpet do jeho stredu
        SetCursorPos Window.Width / 2, mouse.y
        Cam.roty = IIf(Abs(Cam.roty) = 359, 0, (Cam.roty + steepRotX))
      End If
    End If
     
    'pohled nahoru a dolu bez pouziti velikosti kroku
    ' a omezeni pretoceni (zjednoduseno)
    Cam.rotx = mouse.y - ((Window.Width / 180))
    lastX = mouse.x
  
  'filtrujeme klavesy
  Case vbKeyUp  'krok vpred
    Cam.posx = Cam.posx - (Sin((Cam.roty) * (3.14 / 180)) * steepPosY)
    Cam.posz = Cam.posz - (Cos((Cam.roty) * (3.14 / 180)) * steepPosY)
  Case vbKeyDown  'krok vzad
    Cam.posx = Cam.posx + (Sin((Cam.roty) * (3.14 / 180)) * steepPosY)
    Cam.posz = Cam.posz + (Cos((Cam.roty) * (3.14 / 180)) * steepPosY)
  Case vbKeyRight 'ukrok vpravo
    Cam.posx = (Cam.posx - (Sin((Cam.roty - 90) * (3.14 / 180))) * steepPosX)
    Cam.posz = (Cam.posz - (Cos((Cam.roty - 90) * (3.14 / 180))) * steepPosX)
  Case vbKeyLeft  'ukrok vlevo
    Cam.posx = (Cam.posx - (Sin((Cam.roty + 90) * (3.14 / 180))) * steepPosX)
    Cam.posz = (Cam.posz - (Cos((Cam.roty + 90) * (3.14 / 180))) * steepPosX)
End Select

CamposX = -Cam.posx
CamposY = Cam.posy
CamposZ = -Cam.posz
CamrotY = 360 - Cam.roty
CamrotX = Cam.rotx

End Sub

